#if configUSE_EVENTS

#define uxAutoReset pcReadFrom
#define EVENT_MANUALRESET (void*)0
#define EVENT_AUTORESET (void*)1

#define EVENT_PRIORITY configMAX_PRIORITIES

xQUEUE* xQueueCreateEvent(int initialState, int autoreseting)
{
	//Normalize initialState to 0 or 1;
	initialState = initialState ? 1 : 0;

	if (autoreseting) initialState = 0;

	xQUEUE* ret = xQueueCreateCountingSemaphore(1,initialState);
	ret->uxAutoReset = (void*)autoreseting;

	return ret;
}

portBASE_TYPE xEventWait(xQUEUE* event, portTickType xTicksToWait)
{
	/*
	 * This is a little bit of a hack now, should be cleaned up a wee bit later.
	 * When returning, we should wake up other tasks by iterating over the list ourselves, and not
	 * by repeatedly setting the semaphore.
	 */

	//Setting a high priority makes sure that all waiting tasks are unblocked before returning from this function.
	//This prevents a concurrency issue, when a higher priority task is woken up, and the CPU is given to it.
	portBASE_TYPE priority = uxTaskPriorityGet(NULL);
	vTaskPrioritySet(NULL, EVENT_PRIORITY);


	//This operation empties the queue.
	portBASE_TYPE ret = xQueueGenericReceive(event, NULL, xTicksToWait, pdFALSE);

	//If there are more tasks waiting for the queue, 'set' the event again to wake them up as well
	//(or) If there are no more tasks waiting, but the event should be manually reset, also set the event again, so future evnet waits will not block.
	if ((event->xTasksWaitingToReceive.uxNumberOfItems > 0) || (event->uxAutoReset == EVENT_MANUALRESET)) xQueueGenericSend(event, NULL, 0, 0);

	vTaskPrioritySet(NULL, priority);

	return ret;
}


#endif

